from typing import Any, Dict, Optional
from fastapi import HTTPException, status


class DuplicatedError(HTTPException):
    def __init__(self, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_409_CONFLICT, detail=detail, headers=headers)


class AuthError(HTTPException):
    def __init__(self, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_403_FORBIDDEN, detail=detail, headers=headers)


class NotFoundError(HTTPException):
    def __init__(self, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_404_NOT_FOUND, detail=detail, headers=headers)


class ValidationError(HTTPException):
    def __init__(self, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_422_UNPROCESSABLE_ENTITY, detail=detail, headers=headers)


class PermissionDeniedError(HTTPException):
    def __init__(self, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_403_FORBIDDEN, detail=detail, headers=headers)


class UnauthorizedError(HTTPException):
    def __init__(self, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_401_UNAUTHORIZED, detail=detail, headers=headers)


class BadRequestError(HTTPException):
    def __init__(self, detail: Any = "Bad Request", headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_400_BAD_REQUEST, detail=detail, headers=headers)


class ConflictError(HTTPException):
    def __init__(self, detail: Any = "Conflict", headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_409_CONFLICT, detail=detail, headers=headers)


class InternalServerError(HTTPException):
    def __init__(self, detail: Any = "Internal Server Error", headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_500_INTERNAL_SERVER_ERROR, detail=detail, headers=headers)


class RateLimitExceededError(HTTPException):
    def __init__(self, detail: Any = "Too Many Requests", headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_429_TOO_MANY_REQUESTS, detail=detail, headers=headers)


class ServiceUnavailableError(HTTPException):
    def __init__(self, detail: Any = "Service Unavailable", headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status.HTTP_503_SERVICE_UNAVAILABLE, detail=detail, headers=headers)


class GenericHttpError(HTTPException):
    def __init__(self, status_code: int, detail: Any = None, headers: Optional[Dict[str, Any]] = None) -> None:
        super().__init__(status_code=status_code, detail=detail, headers=headers)
